<?php

/* For debugging purposes */
$default->error_level               = 15;

/* The longest that things like file uploads and slow functions should be
 * allowed to run. 0 means run until termination (forever if infinite loop).
 * NOTE: you can't set this to 0 if safe_mode is on. */
$default->max_execution_time        = 0;

/* Server Specific Configuration */
$default->localhost                 = 'burn.isc.rit.edu';

/* Imap Server Default */
$default->server                    = 'vmsimap.isc.rit.edu';
$default->from_server               = 'rit.edu';
$default->port                      = 143;

/* Web server configuration */
$default->root_url                  = '/core/imp';
$default->include_dir               = './templates';
$default->graphics_url              = $default->root_url . '/graphics';

/* Folder configuration */
$default->folders                   = 'Mail/';
$default->use_imap_subscribe        = true;
$default->show_dotfiles             = false;
$default->sent_mail                 = 'sent-mail';
$default->save_sent_mail            = true;
$default->postponed                 = 'postponed-msgs';

/* Allow caching of the pages */
$default->cache_pages               = false;

/* Ldap searching */
$default->use_ldap_search           = true;

/* New User link */
$default->newuser_link				= true;

/* user is presented with an list of available imap servers */
$default->use_server_list           = true;

/* User changable items */
$default->user_change_server        = false;
$default->user_change_folder        = true;
$default->user_change_from          = false;
$default->user_change_fullname      = true;
$default->user_use_addressbook      = false;

/* New mail configuration */
/* Refresh between check for new mail */
$default->refresh_delay		         = 300;
$default->newmail_popup		         = true;

/* Cookie configuration */
$default->session_enabled           = false;
$default->session_timeout           = 300;
$default->cookie_timeout            = 10000;

/* Path to sendmail */
$default->path_to_sendmail          = '/usr/sbin/sendmail';

/* Ispell setup */
$default->path_to_ispell            = '/usr/bin/ispell';

/* Mswordview setup */
$default->path_to_mswordview        = '/usr/bin/mswordview -c';

/* path to tar so that tarballs can be listed */
$default->path_to_tar               = '/bin/tar';

/* SSL Configuration block */
$default->secure                    = true;

/* Cyrus configuration block */
$default->personal_folders          = '';

/* Default Language */
$default->language                  = 'en';

$default->append_header             = true;
$default->append_trailer            = false;

$default->text_parts_inline         = true;

/* database config */
$default->use_db                    = false;
$default->db_user_name              = 'nobody';
$default->db_password               = '';
$default->db_name                   = 'test';
$default->db_server_name            = 'localhost';
$default->db_pref_table             = 'imp_pref';
$default->db_address_table          = 'imp_addr';
$default->db_connect_string         = '';
$default->db_server_port            = '';
$default->db_server_options         = '';
$default->db_server_tty             = '';

?>
