/* IMP database creation script for Sybase */

/* (c) Mike Hardy, 1999 released under the GPL */
/* see the file COPYING in this distribution for license info */

/* To initialize the Sybase ASE SQL Server for IMP do this: */
/* <prompt>% isql -i sybase_create.sql -U<username> -P<password> */

set nocount on

/* I assume you have already created the database "imp" */
use imp
go

IF EXISTS (SELECT * FROM imp.dbo.sysobjects WHERE name = "imp_pref")
BEGIN
DROP TABLE imp_pref
END
GO

CREATE TABLE imp_pref (
       username	      VARCHAR(255) NOT NULL,
       sig	      TEXT NULL,
       fullname	      VARCHAR(70) NULL,
       replyto	      VARCHAR(70) NULL,
       lang	      VARCHAR(70) NULL
)
GO

IF EXISTS (SELECT * FROM imp.dbo.sysobjects WHERE name = "imp_addr")
BEGIN
DROP TABLE imp_addr
END
GO

CREATE TABLE imp_addr (
       username	      VARCHAR(255) NOT NULL,
       address	      VARCHAR(255) NULL,
       nickname	      VARCHAR(255) NULL,
       fullname	      VARCHAR(255) NULL
)
GO

IF EXISTS (SELECT * FROM imp.dbo.sysobjects WHERE name = "imp_log")
BEGIN
DROP TABLE imp_log
END
GO

CREATE TABLE imp_log (
       username	      VARCHAR(255) NOT NULL,
       ts	      DATETIME NULL,
       event	      INTEGER NULL,
       target	      VARCHAR(255) NULL,
       log	      VARCHAR(255) NULL,
       md5	      VARCHAR(255) NULL
)
GO

GRANT Select,Insert,Update,Delete ON imp_log TO nobody
GRANT Select,Insert,Update,Delete ON imp_addr TO nobody
GRANT Select,Insert,Update,Delete ON imp_pref TO nobody
GO
