<?php

/*
 
 File: status.php3
 $Author: mhardy $
 $Revision: 1.40 $
 $Date: 1999/04/20 00:15:55 $
 
 IMP: Copyright 1998, 1999 by Charles J. Hagenbuch <chuck@horde.org>
 
 You should have received a copy of the GNU Public
 License along with this package; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.
 
 */

$need_horde_db = 0;
$db_lib_loaded = 0;
if (!defined("HORDE_LIB")) include ('../lib/horde.lib');
require ('./lib/imp.lib');
require ('./config/defaults.php3');

/* Html styles configuration */
require ('./config/html.php3');
require ('./config/mailbox.php3');

/* get some locale stuff defined elsewhere to minimize locale impact */
$language = select_lang();
require ("./locale/$language/message.lang");
require ("./locale/local/message.lang");
$Lang_From = $lang->from;
$Lang_Subject = $lang->subject;
/* end relocatable stuff (for 2.1) */

$language = select_lang();
require ("./locale/$language/status.lang");
require ('./locale/local/status.lang');

/* send headers to ensure that the page will reload correctly. */
caching_headers();

/* can we log in? */
$session = create_session_object();
$user    = $session->get_user();
$pass    = $session->get_password();
$server  = $session->get_server();
$port    = $session->get_port();
$folders = $session->get_folder();
if (!isset($mailbox)) $mailbox = 'INBOX';


$title = $lang->status_title;
$sidebar = true;

/* doctype */
require("$default->include_dir/doctype.inc");

/* if we can log in, do so and get the mail stats for this mailbox */
if (isset($default->refresh_delay) && isset($user) && $user != '') {
   /* make it refresh */
   $refresh = true;
   
   $mbox = validate_login($server, $port, $mailbox, $user, $pass, OP_READONLY);
   $mailinfo = @imap_mailboxmsginfo($mbox);
   if ($mailinfo) {
      $num_unread = $mailinfo->Unread;
      $num_recent = $mailinfo->Recent;
      $message = $lang->mailbox_status($message, $num_unread, $num_recent);

      /* If they want it, we can give them a "new mail" popup */
      if (isset($default->newmail_popup) && $default->newmail_popup) {
	 if ($num_recent > 0) {
	     
	     /* Grab the From and Header of the most recent one */
	     $h=@imap_header($mbox, imap_msgno($mbox, $msgnum), $default->max_frm_chars, $default->max_sub_chars);
   
	     /* some balky IMAP servers don't get it right at first... */
	     while (!is_object($h) || !imap_ping($mbox)) {
		 $mbox = imap_open("{$server:$port}$mailbox", $user, $pass, OP_READONLY);
		 $h = @imap_header($mbox,$mailinfo->Nmsgs, $default->max_frm_chars, $default->max_sub_chars);
	     }
	     
	     /* initialize the header fields */
	     $frm = '';
	     $sub = '';

	     if(isset($h->from[0])) {
		 $from = $h->from[0];
		 if (isset($from->personal)) {
		     $frm = chop(decode_mime_string($from->personal));
		 } else $frm = $from->mailbox . '@' . $from->host;
	     } elseif (isset($h->fetchfrom)) $frm = $h->fetchfrom;
	     if (isset($h->fetchsubject)) $sub = trim(decode_mime_string($h->fetchsubject));
	     $frm = htmlspecialchars($frm);
	     $sub = htmlspecialchars($sub);

	     echo "<script>onLoad=\"mail_popup()\";";
	     echo 'alert("' . $lang->newmail_msg . '\n\n' .
		 $Lang_From . ': ' .
		 $frm . '\n' .
		 $Lang_Subject . ': ' .
		 $sub . '");</script>';
	 }
      }
   }
}

require("$default->include_dir/generic-header.inc");
require("$default->include_dir/status/body.inc");
require("$default->include_dir/generic-footer.inc");

?>
